io.vertx.ext.web.handler.sockjs

## Interface SockJSSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public interface SockJSSocket
      extends ReadStream<Buffer>, WriteStream<Buffer>

  You interact with SockJS clients through instances of SockJS socket.

  The API is very similar to `WebSocket`. It implements both `ReadStream` and `WriteStream` so it can be used with `Pump` to pump data with flow control.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close it
    `default void` | `close(int statusCode, String reason)` Close it giving a status code and reason.
    `SockJSSocket` | `closeHandler(Handler<Void> closeHandler)`
    `SockJSSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `Future<Void>` | `end()` Call `close()`.
    `SockJSSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `SockJSSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `SockJSSocket` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `SockJSSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `MultiMap` | `headers()` Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons
    `SocketAddress` | `localAddress()` Return the local address for this socket
    `SockJSSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `SocketAddress` | `remoteAddress()` Return the remote address for this socket
    `SockJSSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `RoutingContext` | `routingContext()`
    `SockJSSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `String` | `uri()` Return the URI corresponding to the last request for this socket or the websocket handshake
    `Session` | `webSession()`
    `User` | `webUser()`
    `default Future<Void>` | `write(Buffer data)` Write some data to the stream.
    `void` | `write(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `#write(T)` but with an `handler` called when the operation completes
    `default Future<Void>` | `write(String data)` Write a `String` to the socket, encoded in UTF-8.
    `default void` | `write(String data, Handler<AsyncResult<Void>> handler)`
    `String` | `writeHandlerID()` When a `SockJSSocket` is created it can register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, end, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          SockJSSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          SockJSSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          SockJSSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          SockJSSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          SockJSSocket fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          SockJSSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          SockJSSocket closeHandler(Handler<Void> closeHandler)

    - #### write

          default Future<Void> write(Buffer data)

      Description copied from interface: `WriteStream`
      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a `Pipe`.

      When the `data` is moved from the queue to the actual medium, the returned `Future` will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### write

          default Future<Void> write(String data)

      Write a `String` to the socket, encoded in UTF-8.
      Parameters:
        `data` - the string to write

    - #### write

          default void write(String data,
                             Handler<AsyncResult<Void>> handler)

    - #### write

          void write(Buffer data,
                     Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WriteStream`
      Same as `#write(T)` but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WriteStream<Buffer>`

    - #### setWriteQueueMaxSize

          SockJSSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          SockJSSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          String writeHandlerID()

      When a `SockJSSocket` is created it can register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying socket. This allows you to write data to other sockets which are owned by different event loops.

      Returns:
        the `writeHandlerID` or `null` if `writeHandler` registration is disabled in `SockJSHandlerOptions`

    - #### end

          Future<Void> end()

      Call `close()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### close

          void close()

      Close it

    - #### close

          default void close(int statusCode,
                             String reason)

      Close it giving a status code and reason. Only Applicable to RawWebSocket will downgrade to plain close for other transports.

    - #### remoteAddress

          SocketAddress remoteAddress()

      Return the remote address for this socket

    - #### localAddress

          SocketAddress localAddress()

      Return the local address for this socket

    - #### headers

          MultiMap headers()

      Return the headers corresponding to the last request for this socket or the websocket handshake Any cookie headers will be removed for security reasons

    - #### uri

          String uri()

      Return the URI corresponding to the last request for this socket or the websocket handshake

    - #### routingContext

          RoutingContext routingContext()

      Returns:
        the Vert.x-Web RoutingContext corresponding to this socket

    - #### webSession

          Session webSession()

      Returns:
        the Vert.x-Web session corresponding to this socket

    - #### webUser

          User webUser()

      Returns:
        the Vert.x-Web user corresponding to this socket

Copyright © 2021 Eclipse. All rights reserved.